
unit Iobroker;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellApi, IdBaseComponent, IdComponent, IdTCPServer,
  IdCustomHTTPServer, IdHTTPServer, INIfiles, ComCtrls, Buttons,
   Menus, Registry, tlhelp32, IdTCPConnection, IdTCPClient,
  IdHTTP, ExtCtrls, CoolTrayIcon;

type
  TServer = class(TForm)
    IdHTTPServer1: TIdHTTPServer;
    BtnSave: TButton;
    CoolTrayIcon1: TCoolTrayIcon;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    IdHTTP1: TIdHTTP;
    BitBtn17: TBitBtn;
    OpenDialog1: TOpenDialog;
    GroupBox1: TGroupBox;
    MainServer: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    MainServerPort: TEdit;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    SimpleAPI_IP: TEdit;
    SimpleAPI_Port: TEdit;
    Label8: TLabel;
    GroupBox3: TGroupBox;
    StartUp: TCheckBox;
    ToTray: TCheckBox;
    GroupBox4: TGroupBox;
    Label9: TLabel;
    Label6: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    ScrollBox1: TScrollBox;
    Label13: TLabel;
    StatusBar1: TStatusBar;
    Label5: TLabel;
    Count1: TEdit;
    Language: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure IdHTTPServer1CommandGet(AThread: TIdPeerThread;
    ARequestInfo: TIdHTTPRequestInfo;
    AResponseInfo: TIdHTTPResponseInfo);
    procedure BtnSaveClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure ClickerOpenpath(Sender: TObject);
    procedure ClickTedit(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn17Click(Sender: TObject);
    procedure Label3DblClick(Sender: TObject);
    procedure Label13Click(Sender: TObject);
    procedure ScrollBox1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ScrollBox1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure CoolTrayIcon1DblClick(Sender: TObject);
    procedure CoolTrayIcon1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ControlWindow(var Msg: TMessage); message WM_SysCommand;
      
  private
    { Private declarations }
  public
    function EXE_Running(FileName: string; bFullpath: Boolean): Boolean;
    procedure GetRunProcess(ProcesList: TStringList);
  end;

var
  Server: TServer;
  H: THandle;
  path, command, param, showas: Array of TEdit;
  //showas: Array of TComboBox;
  openpath: Array of TBitBtn;
  indexOpenpath: byte;
  indexClickTedit: Integer;
  ProcesList: TStringList;
  version, Runexe, NotRun_exe,Incoming:String;
  rez :TModalResult;


implementation

uses Unit2;

{$R *.dfm}

Function SetPrivilege(aPrivilegeName: String; aEnabled: Boolean ): Boolean;
Var
 hToken: THandle;
 tkp: TTokenPrivileges;
 ReturnLength: Cardinal;
Begin
  Result:=False;
  if OpenProcessToken(GetCurrentProcess( ), TOKEN_ADJUST_PRIVILEGES or
  TOKEN_QUERY, hToken) then
begin
  LookupPrivilegeValue(nil, 'SeShutdownPrivilege', tkp.Privileges[0].Luid);
  tkp.PrivilegeCount := 1;
  tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
    Result:=AdjustTokenPrivileges(hToken, False, tkp, 0, nil, ReturnLength);
  End;
  CloseHandle(hToken);
End;

procedure Autorun(Flag:boolean; NameParam, Path:String);
var Reg:TRegistry;
begin
  if Flag then
  begin
     Reg := TRegistry.Create;
     Reg.RootKey := HKEY_CURRENT_USER;
     Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Run', false);
     Reg.WriteString(NameParam, Path);
     Reg.Free;
  end
  else
  begin
     Reg := TRegistry.Create;
     Reg.RootKey := HKEY_CURRENT_USER;
     Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Run',false);
     Reg.DeleteValue(NameParam);
     Reg.Free;
  end;
end;
///////*******************************************************************************
procedure TServer.FormCreate(Sender: TObject);
var appINI:TIniFile;I:integer;
     CmdStr,PathStr,paramStr, showasStr:String;
     About : TAbout;
     m,n,k,step,Count:integer;
     Hint_Command, Hint_Path, Hint_Param, Hint_Showas,
     Ver, Ready, Hint_Openpath, MinTray, StrtUp,
     NumLin,Option,Serv,Lst,Save,bQuit, ListCmd, Listpath, Listparam, Listshow,
     ServerHint,SerportHint,SimpleHint,SimportHint,NumLinHint,
     MinTrayHint,StrtUpHint,SaveHint,bQuitHint:String;

begin
//====================================/
  version:='2.6'; //==================/
//====================================/
  if FileExists(ExtractFilePath(Application.ExeName)+'GetAdmin.ini') then
    begin
    end
  else
    begin
      About := TAbout.Create(Self);
      About.BorderStyle := bsDialog;
      About.version.Caption := version;
      About.label5.AutoSize := False;
      //About.label5.Caption := '    " " ("AS IS").      .          .'+'           ,            .';
        About.label5.Caption := 'The program is delivered by a principle "AS IS". No warranty is not attached and is not provided. You use this software at your own risk.'+' The author will not be responsible for any loss or corruption of data, any loss of profit during use or misuse of this software.';
      About.Label6.Cursor := crHandPoint;
      About.Label6.Font.Color := clBlue;

      rez := About.ShowModal;
      About.Free;
      //if rez = mrOK then MessageDlg(' .', mtInformation, [mbYes], 0);
      //if rez = mrCancel then MessageDlg(' .', mtInformation, [mbYes], 0);
    end;
 appINI := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini')) ;
 Language.ItemIndex := StrToInt(appINI.ReadString('Properties','Lang','1'));

 /////
      if Language.ItemIndex = 1 then
      begin
        Hint_Command := 'The command to start the application';
        Hint_Path :='The path to the startup file, you can specify the URL of the page (it opens in your default browser)';
        Hint_Showas :='SW_SHOWNORMAL'+#13+'SW_SHOWMINIMIZED'+#13+'SW_SHOWMAXIMIZED'+#13+'SW_RESTORE';
        Ver := 'Ver. ';
        Incoming:= 'Incoming: ';
        Ready:='Ready...';
        Hint_Openpath:='Select the path to the file';
        Hint_Param:='Startup Options.'+#13+'For example, for foobar2000:'+#13+'/play'+#13+'/rand'+#13+'/exit';
        NotRun_exe:=' Not running or was not found!';
        Runexe:=' Running!';
        MinTray:='Minimize on Tray';
        StrtUp:= 'StartUp';
        NumLin:='Number of lines:';
        Option:='Options';
        Serv:='Server';
        Lst:='Command list';
        Save:='Save';
        bQuit:='Quit';
        ListCmd :='COMMAND';
        Listpath :='PATH or URL';
        Listparam:='PARAMETERS';
        Listshow :='SHOW CMD';
        ServerHint:='IP address of your computer';
        SerportHint:='Port that will run GetAdmin';
        SimpleHint:= 'The IP address of the SimpleAPI IOBroker';
        SimportHint:='The port is running the SimpleAPI of IOBroker';
        NumLinHint:='The number of lines of commands (max 100)';
        MinTrayHint:='Minimize to tray at program startup';
        StrtUpHint:='Add to Startup';
        SaveHint:='Save';
        bQuitHint:='Exit the program';
        Incoming:= 'Incoming: ';
      end;
      if Language.ItemIndex = 0 then
      begin
        Hint_Command := '   ';
        Hint_Path :='    URL (URL    -)';
        Hint_Showas :='SW_SHOWNORMAL'+#13+'SW_SHOWMINIMIZED'+#13+'SW_SHOWMAXIMIZED'+#13+'SW_RESTORE';
        Ver := ': ';
        Ready:='...';
        Hint_Openpath:=' ';
        Hint_Param:=' .'+#13+'  foobar2000:'+#13+'/play'+#13+'/rand'+#13+'/exit';
        NotRun_exe:='     !';
        Runexe:=' !';
        MinTray:='  ';
        StrtUp:= '';
        NumLin:='- :';
        Option:='';
        Serv:='';
        Lst:=' ';
        Save:='';
        bQuit:='';
        ListCmd :='';
        Listpath :='    URL';
        Listparam:='';
        Listshow :=' ';
        Label11.Left:=620;
        ServerHint:='IP   ';
        SerportHint:='     GetAdmin';
        SimpleHint:= 'IP   SimpleAPI  IOBroker';
        SimportHint:='    SimpleAPI  IOBroker';
        NumLinHint:='     (. 100)';
        MinTrayHint:='    ';
        StrtUpHint:='   Windows';
        SaveHint:=' ';
        bQuitHint:='  ';
        Incoming:= ': ';
      end;
 /////////
 ToTray.Caption:=MinTray;
 ToTray.Hint:=MinTrayHint;
 StartUp.Caption:=StrtUp;
 StartUp.Hint:=StrtUpHint;
 Label5.Caption:= NumLin;
 GroupBox3.Caption:=Option;
 GroupBox1.Caption:=Serv;
 GroupBox4.Caption:=Lst;
 BtnSave.Caption:=Save;
 BtnSave.Hint:=SaveHint;
 BitBtn17.Caption:=bQuit;
 BitBtn17.Hint:=bQuitHint;
 Label6.Caption:=ListCmd;
 Label9.Caption:=Listpath;
 Label10.Caption:=Listparam;
 Label11.Caption:=Listshow;
 MainServer.Hint:= ServerHint;
 MainServerPort.Hint:= SerportHint;
 SimpleAPI_IP.Hint:=SimpleHint;
 SimpleAPI_Port.Hint:=SimportHint;
 Count1.Hint:=NumLinHint;

 StatusBar1.Panels[0].Text := Ver+version;
 StatusBar1.Panels[1].Text := Incoming;
 StatusBar1.Panels[2].Text := Ready;
 PathStr:='';
 CmdStr:='';
 paramStr :='';
 showasStr :='SW_SHOWNORMAL';

SetLength(command, StrToInt(appINI.ReadString('Properties','Count','10000'))+1000);
SetLength(path, StrToInt(appINI.ReadString('Properties','Count','10000'))+1000);
SetLength(openpath, StrToInt(appINI.ReadString('Properties','Count','10000'))+1000);
SetLength(param, StrToInt(appINI.ReadString('Properties','Count','10000'))+1000);
SetLength(showas, StrToInt(appINI.ReadString('Properties','Count','10000'))+1000);


   try
     MainServerPort.Text:= appINI.ReadString('Properties','Port','8585') ;
     MainServer.Text:= appINI.ReadString('Properties','BaseURL','IP address') ;
      if (appINI.ReadString('Properties','AutoStart','0')='0') then
        begin
        StartUp.Checked:=false;
        Autorun(false,'Server', Application.ExeName);
        end
      else begin
        StartUp.Checked:=true;
        Autorun(true,'Server', Application.ExeName);
        //auto start it!
      end;
      if (appINI.ReadString('Properties','ToTray','0')='0') then
        ToTray.Checked:=false
      else begin
        ToTray.Checked:=true;
        PostMessage(Handle, WM_SYSCOMMAND, SC_MINIMIZE, 0);
        //auto start it!
      end;
     SimpleAPI_IP.Text:= appINI.ReadString('Properties','SimpleAPI_IP',PathStr);
     SimpleAPI_Port.Text:= appINI.ReadString('Properties','SimpleAPI_Port',PathStr);
     Count1.Text:= appINI.ReadString('Properties','Count','20') ;
     if (StrtoInt(Count1.Text)>100) then
       Count1.Text := '100';
     ///****
k:=0;
step:=20;
Count:= StrToInt(Count1.Text);

for m:=0 to (Count-1) do
 begin
 inc(k);
  command[m]:=tedit.Create(Owner);
  //command[m].Parent := Owner;
  command[m].Top:=(m*step)+0;
  command[m].Left:=0;
  command[m].Height:= 21;
  command[m].Width:=59;
  command[m].OnDblClick:=ClickTedit;
  command[m].Hint:=Hint_Command;
  command[m].ShowHint:=true;
  //command[m].Name:='command_'+IntToStr(k);
  command[m].Text := appINI.ReadString('Commands','Command_'+IntToStr(m),CmdStr);
    path[m]:= TEdit.Create(Owner);
    //path[m].Parent := Owner;
    path[m].Top:=(m*step)+0;
    path[m].Left:=59;
    path[m].Height:= 21;
    path[m].Width:=354;
    path[m].OnDblClick:=ClickTedit;
    path[m].Hint:=Hint_Path;
    path[m].ShowHint:=true;
    //path[m].Name:='path_'+IntToStr(k);
    path[m].Text := appINI.ReadString('Commands','Path_'+IntToStr(m),PathStr);
  openpath[m]:=TBitBtn.Create(Owner);
  //openpath[m].Parent := Owner;
  openpath[m].Top:=(m*step)+5;
  openpath[m].Left:=414;
  openpath[m].Height:= 16;
  openpath[m].Width:=19;
  openpath[m].Caption:='...';
  openpath[m].Font.Style:=[fsBold];
  openpath[m].Hint:=Hint_Openpath;
  openpath[m].ShowHint:=true;
  openpath[m].Cursor:=crHandPoint;
  openpath[m].OnClick:=ClickerOpenpath;     //
  //openpath[m].Name:='openpath_'+IntToStr(k);
    param[m]:=tedit.Create(Owner);
    //param[m].Parent := Owner;
    param[m].Top:=(m*step)+0;
    param[m].Left:=437;
    param[m].Height:= 21;
    param[m].Width:=179;
    param[m].Hint:=Hint_Param;
    param[m].ShowHint:=true;
    param[m].OnDblClick:=ClickTedit;
    //param[m].Name:='param_'+IntToStr(k);
    param[m].Text := appINI.ReadString('Commands','Param_'+IntToStr(m),paramStr);
  showas[m]:=tedit.Create(Owner);
  //showas[m].Parent := Owner;
  showas[m].Top:=(m*step)+0;
  showas[m].Left:=608;
  showas[m].Height:= 21;
  showas[m].Width:=115;
  showas[m].Hint:=Hint_Showas;
  showas[m].ShowHint:=true;
  showas[m].OnDblClick:=ClickTedit;
  //showas[m].Name:='show_'+IntToStr(k);
  showas[m].Text := appINI.ReadString('Commands','Show_'+IntToStr(m),'SW_SHOWNORMAL');
    ScrollBox1.InsertControl(command[m]);
    ScrollBox1.InsertControl(path[m]);
    ScrollBox1.InsertControl(openpath[m]);
    ScrollBox1.InsertControl(param[m]);
    ScrollBox1.InsertControl(showas[m]);
   //pathArr[k]:= 'path_'+IntToStr(k);
 end;

   finally
     appINI.Free;
  end;
  idHTTPServer1.DefaultPort:= StrToInt(MainServerPort.Text);
  idHttpserver1.Active:=true; // 

end;

//////////////////************************************////////////////////////
procedure TServer.IdHTTPServer1CommandGet(AThread: TIdPeerThread;
  ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
var
  name, value, ProcListResponse, NameFile: string;
  i, n, m, x, showCmd, flagkey: Integer;
  hSnapShot: THandle;
  ProcInfo: TProcessEntry32;
  ProcesList, key: TStringList;
  HotKey:Array of Byte;

begin
/////
      if Language.ItemIndex = 1 then
      begin
        NotRun_exe:=' Not running or was not found!';
        Runexe:=' Running!';
        Incoming:= 'Incoming: ';
      end;
      if Language.ItemIndex = 0 then
      begin
        NotRun_exe:='     !';
        Runexe:=' !';
        Incoming:= ': ';
      end;
 /////////
SetLength(HotKey, 10);
  for i := 0 to ARequestInfo.Params.Count-1 do
  begin
    Name := ARequestInfo.Params.Names[i];
    Value := ARequestInfo.Params.ValueFromIndex[i];
    showCmd := 9;
    flagkey := 0;
    StatusBar1.Panels[1].Text := Incoming+Value;
    if Name = 'cmd' then
    begin
    for m:=0 to (StrToInt(Count1.Text)-1) do
      begin
        if Value = command[m].Text then
         begin
           if (showas[m].Text = 'SW_SHOWNORMAL') then showCmd := 1;
           if (showas[m].Text = 'SW_HIDE') then showCmd := 0;
           if (showas[m].Text = 'SW_MAXIMIZE') then showCmd := 3;
           if (showas[m].Text = 'SW_MINIMIZE') then showCmd := 6;
           if (showas[m].Text = 'SW_RESTORE') then showCmd := 9;
           if (showas[m].Text = 'SW_SHOW') then showCmd := 5;
           if (showas[m].Text = 'SW_SHOWDEFAULT') then showCmd := 10;
           if (showas[m].Text = 'SW_SHOWMAXIMIZED') then showCmd := 3;
           if (showas[m].Text = 'SW_SHOWMINIMIZED') then showCmd := 2;
           if (showas[m].Text = 'SW_SHOWMINNOACTIVE') then showCmd := 7;
           if (showas[m].Text = 'SW_SHOWNA') then showCmd := 8;
           if (showas[m].Text = 'SW_SHOWNOACTIVATE') then showCmd := 4;
           ShellExecute (Server.Handle,'open', Pchar(path[m].Text), PAnsiChar(param[m].Text) , nil, showCmd);
            NameFile:= ExtractFileName(path[m].Text);
            if EXE_Running(NameFile, False) then
              AResponseInfo.ContentText:='<html>Ok!<p>'+path[m].Text+'</p></html>'
            else
              AResponseInfo.ContentText:='<html>Error!<p>'+path[m].Text+'</p></html>';
           Break;
         end;
      end;
         if Value = 'shutdown' then
          begin
          //ShellExecute(handle, nil,'shutdown',' -s -t 00','', SW_SHOWNORMAL);
            SetPrivilege('SeShutdownPrivilege',True);
            ExitWindowsEx(EWX_SHUTDOWN or ewx_force,0);
            Break;
          end;
        if Value = 'poweroff' then
          begin
            SetPrivilege('SeShutdownPrivilege',True);
            ExitWindowsEx(EWX_POWEROFF or ewx_force,0);
            Break;
          end;
        if Value = 'logoff' then
          begin
          //ShellExecute(handle, nil,'shutdown',' - -t 00','', SW_SHOWNORMAL);
            SetPrivilege('SeShutdownPrivilege',True);
            ExitWindowsEx(EWX_LOGOFF or ewx_force,0);
            Break;
          end;
        if Value = 'reboot' then
          begin
          //ShellExecute(handle, nil,'shutdown',' -r -t 00','', SW_SHOWNORMAL);
            SetPrivilege('SeShutdownPrivilege',True);
            ExitWindowsEx(EWX_REBOOT or ewx_force,0);
            Break;
          end;
        if Value = 'forceifhung' then
          begin
            SetPrivilege('SeShutdownPrivilege',True);
            ExitWindowsEx(EWX_FORCEIFHUNG or ewx_force,0);
            Break;
          end;

        if Value = 'process' then
        begin
           ProcesList := TStringList.Create;
           hSnapShot := CreateToolHelp32Snapshot(TH32CS_SNAPPROCESS, 0);
             if (hSnapShot <> THandle(-1)) then
                begin
                 ProcInfo.dwSize := SizeOf(ProcInfo);
                  if (Process32First(hSnapshot, ProcInfo)) then
                    begin
                     while (Process32Next(hSnapShot, ProcInfo)) do
                     ProcesList.Add(ProcInfo.szExeFile);
                    end;
                 CloseHandle(hSnapShot);
                end;
              for n := 1 to ProcesList.Count-1 do
              begin
               ProcListResponse := ProcListResponse + ProcesList[n]+';';
              end;
              AResponseInfo.ContentText:='<html>'+ProcListResponse+'</html>';
              Break;
         end;

         if Value = 'monitor1' then
          begin
             WinExec(Pchar('displayswitch.exe /external'),SW_SHOW);
            Break;
          end;
         if Value = 'monitor2' then
          begin
            WinExec(Pchar('displayswitch.exe /internal'),SW_SHOW);
            Break;
          end;
          if Value = 'monitorclone' then
          begin
             WinExec(Pchar('displayswitch.exe /clone'),SW_SHOW);
            Break;
          end;
          if Value = 'monitorextend' then
          begin
             WinExec(Pchar('displayswitch.exe /extend'),SW_SHOW);
            Break;
          end;
    end;
    if Name = 'chk' then
      begin
          if Value <> '' then
           begin
             Value := Value+'.exe';
            if EXE_Running(Value, False) then
              AResponseInfo.ContentText:='<html>'+Value+Runexe+'<p>true</p></html>'
            else
              AResponseInfo.ContentText:='<html>'+Value+NotRun_exe+'<p>false</p></html>';

            Break;
           end;
      end;

      if Name = 'key' then
      begin
        if Value <> '' then
          begin
           key := TStringList.Create;
          try
            key.Delimiter := '+';
            // key.StrictDelimiter := True;
            key.DelimitedText := Value;
          finally

          for n:=0 to key.Count-1 do
            begin
              if key[n] = 'CTRL' then begin HotKey[n] := $A2; end;
              if key[n] = 'RCTRL' then begin HotKey[n] := $A3; end;
              if key[n] = 'ALT' then begin HotKey[n] := $A4; end;
              if key[n] = 'RALT' then begin HotKey[n] := $A5; end;
              if key[n] = 'SHIFT' then begin HotKey[n] := $A0; end;
              if key[n] = 'RSHIFT' then begin HotKey[n] := $A1; end;
              if key[n] = 'WIN' then begin HotKey[n] := $5B; end;
              if key[n] = 'RWIN' then begin HotKey[n] := $5C; end;
              if key[n] = 'ESC' then begin HotKey[n] := $1B; end;
              if key[n] = 'ENT' then begin HotKey[n] := $0D; end;
              if key[n] = 'DEL' then begin HotKey[n] := $2E; end;
              if key[n] = 'INS' then begin HotKey[n] := $2D; end;
              if key[n] = 'VOLUP' then begin HotKey[n] := $AF; end;
              if key[n] = 'VOLDN' then begin HotKey[n] := $AE; end;
              if key[n] = 'MUTE' then begin HotKey[n] := $AD; end;
              if key[n] = 'NEXT' then begin HotKey[n] := $B0; end;
              if key[n] = 'PREV' then begin HotKey[n] := $B1; end;
              if key[n] = 'PLAY' then begin HotKey[n] := $B3; end;
              if key[n] = 'STOP' then begin HotKey[n] := $B2; end;
              if key[n] = 'BACK' then begin HotKey[n] := $08; end;
              if key[n] = 'SPACE' then begin HotKey[n] := $20; end;
              if key[n] = 'TAB' then begin HotKey[n] := $09; end;
              if key[n] = 'NUMP' then begin HotKey[n] := $6B; end;
              if key[n] = 'NUMS' then begin HotKey[n] := $6F; end;
              if key[n] = 'NUMD' then begin HotKey[n] := $6E; end;
              if key[n] = 'NUM*' then begin HotKey[n] := $6A; end;
              if key[n] = 'NUMM' then begin HotKey[n] := $6D; end;
              if key[n] = 'NUML' then begin HotKey[n] := $90; end;
              if key[n] = 'CAPS' then begin HotKey[n] := $14; end;
              if key[n] = 'END' then begin HotKey[n] := $23; end;
              if key[n] = 'HOME' then begin HotKey[n] := $24; end;
              if key[n] = 'PGDN' then begin HotKey[n] := $22; end;
              if key[n] = 'PGUP' then begin HotKey[n] := $21; end;
              if key[n] = 'SCRL' then begin HotKey[n] := $91; end;
              if key[n] = 'PRNTSCR' then begin HotKey[n] := $2C; end;
              if key[n] = 'SLEEP' then begin HotKey[n] := $5F; end;
              if key[n] = 'DOWN' then begin HotKey[n] := $28; end;
              if key[n] = 'UP' then begin HotKey[n] := $26; end;
              if key[n] = 'LEFT' then begin HotKey[n] := $25; end;
              if key[n] = 'RIGHT' then begin HotKey[n] := $27; end;
              if key[n] = 'F1' then begin HotKey[n] := $70; end;
              if key[n] = 'F2' then begin HotKey[n] := $71; end;
              if key[n] = 'F3' then begin HotKey[n] := $72; end;
              if key[n] = 'F4' then begin HotKey[n] := $73; end;
              if key[n] = 'F5' then begin HotKey[n] := $74; end;
              if key[n] = 'F6' then begin HotKey[n] := $75; end;
              if key[n] = 'F7' then begin HotKey[n] := $76; end;
              if key[n] = 'F8' then begin HotKey[n] := $77; end;
              if key[n] = 'F9' then begin HotKey[n] := $78; end;
              if key[n] = 'F10' then begin HotKey[n] := $79; end;
              if key[n] = 'F11' then begin HotKey[n] := $7A; end;
              if key[n] = 'F12' then begin HotKey[n] := $7B; end;
              if key[n] = 'F13' then begin HotKey[n] := $7C; end;
              if key[n] = 'F14' then begin HotKey[n] := $7D; end;
              if key[n] = 'F15' then begin HotKey[n] := $7E; end;
              if key[n] = 'F16' then begin HotKey[n] := $7F; end;
              if key[n] = 'F17' then begin HotKey[n] := $80; end;
              if key[n] = 'F18' then begin HotKey[n] := $81; end;
              if key[n] = 'F19' then begin HotKey[n] := $82; end;
              if key[n] = 'F20' then begin HotKey[n] := $83; end;
              if key[n] = 'F21' then begin HotKey[n] := $84; end;
              if key[n] = 'F22' then begin HotKey[n] := $85; end;
              if key[n] = 'F23' then begin HotKey[n] := $86; end;
              if key[n] = 'F24' then begin HotKey[n] := $87; end;
              if key[n] = 'NUM0' then begin HotKey[n] := $60; end;
              if key[n] = 'NUM1' then begin HotKey[n] := $61; end;
              if key[n] = 'NUM2' then begin HotKey[n] := $62; end;
              if key[n] = 'NUM3' then begin HotKey[n] := $63; end;
              if key[n] = 'NUM4' then begin HotKey[n] := $64; end;
              if key[n] = 'NUM5' then begin HotKey[n] := $65; end;
              if key[n] = 'NUM6' then begin HotKey[n] := $66; end;
              if key[n] = 'NUM7' then begin HotKey[n] := $67; end;
              if key[n] = 'NUM8' then begin HotKey[n] := $68; end;
              if key[n] = 'NUM9' then begin HotKey[n] := $69; end;
              if key[n] = '0' then begin HotKey[n] := $30; end;
              if key[n] = '1' then begin HotKey[n] := $31; end;
              if key[n] = '2' then begin HotKey[n] := $32; end;
              if key[n] = '3' then begin HotKey[n] := $33; end;
              if key[n] = '4' then begin HotKey[n] := $34; end;
              if key[n] = '5' then begin HotKey[n] := $35; end;
              if key[n] = '6' then begin HotKey[n] := $36; end;
              if key[n] = '7' then begin HotKey[n] := $37; end;
              if key[n] = '8' then begin HotKey[n] := $38; end;
              if key[n] = '9' then begin HotKey[n] := $39; end;
              if key[n] = 'A' then begin HotKey[n] := $41; end;
              if key[n] = 'B' then begin HotKey[n] := $42; end;
              if key[n] = 'C' then begin HotKey[n] := $43; end;
              if key[n] = 'D' then begin HotKey[n] := $44; end;
              if key[n] = 'E' then begin HotKey[n] := $45; end;
              if key[n] = 'F' then begin HotKey[n] := $46; end;
              if key[n] = 'G' then begin HotKey[n] := $47; end;
              if key[n] = 'H' then begin HotKey[n] := $48; end;
              if key[n] = 'I' then begin HotKey[n] := $49; end;
              if key[n] = 'J' then begin HotKey[n] := $4A; end;
              if key[n] = 'K' then begin HotKey[n] := $4B; end;
              if key[n] = 'L' then begin HotKey[n] := $4C; end;
              if key[n] = 'M' then begin HotKey[n] := $4D; end;
              if key[n] = 'N' then begin HotKey[n] := $4E; end;
              if key[n] = 'O' then begin HotKey[n] := $4F; end;
              if key[n] = 'P' then begin HotKey[n] := $50; end;
              if key[n] = 'Q' then begin HotKey[n] := $51; end;
              if key[n] = 'R' then begin HotKey[n] := $52; end;
              if key[n] = 'S' then begin HotKey[n] := $53; end;
              if key[n] = 'T' then begin HotKey[n] := $54; end;
              if key[n] = 'U' then begin HotKey[n] := $55; end;
              if key[n] = 'V' then begin HotKey[n] := $56; end;
              if key[n] = 'W' then begin HotKey[n] := $57; end;
              if key[n] = 'X' then begin HotKey[n] := $58; end;
              if key[n] = 'Y' then begin HotKey[n] := $59; end;
              if key[n] = 'Z' then begin HotKey[n] := $5A; end;
               //ShowMessage('  - '+IntToStr(HotKey[n]));
            end;
          if key.Count = 1 then
            begin
              keybd_event(HotKey[0], 0, 0, 0);
              keybd_event(HotKey[0], 0, KEYEVENTF_KEYUP, 0);
              flagkey := 1;
            end;
          if (key.Count = 2) and ((HotKey[0] = $A0) or (HotKey[0] = $A1) or (HotKey[0] = $A2) or (HotKey[0] = $A3) or (HotKey[0] = $A4) or (HotKey[0] = $A5) or (HotKey[0] = $5B) or (HotKey[0] = $5C)) then
            begin
              keybd_event(HotKey[0], 0, 0, 0);
              keybd_event(HotKey[1], 0, 0, 0);
              keybd_event(HotKey[1], 0, KEYEVENTF_KEYUP, 0);
              keybd_event(HotKey[0], 0, KEYEVENTF_KEYUP, 0);
              flagkey := 1;
            end;
           if (key.Count = 3) and ((HotKey[0] = $A0) or (HotKey[0] = $A1) or (HotKey[0] = $A2) or (HotKey[0] = $A3) or (HotKey[0] = $A4) or (HotKey[0] = $A5) or (HotKey[0] = $5B) or (HotKey[0] = $5C)) and
            ((HotKey[1] = $A0) or (HotKey[1] = $A1) or (HotKey[1] = $A2) or (HotKey[1] = $A3) or (HotKey[1] = $A4) or (HotKey[1] = $A5) or (HotKey[1] = $5B) or (HotKey[1] = $5C)) then
            begin
              keybd_event(HotKey[0], 0, 0, 0);
              keybd_event(HotKey[1], 0, 0, 0);
              keybd_event(HotKey[2], 0, 0, 0);
              keybd_event(HotKey[2], 0, KEYEVENTF_KEYUP, 0);
              keybd_event(HotKey[1], 0, KEYEVENTF_KEYUP, 0);
              keybd_event(HotKey[0], 0, KEYEVENTF_KEYUP, 0);
              flagkey := 1;
            end;
            if (key.Count = 4) and ((HotKey[0] = $A0) or (HotKey[0] = $A1) or (HotKey[0] = $A2) or (HotKey[0] = $A3) or (HotKey[0] = $A4) or (HotKey[0] = $A5) or (HotKey[0] = $5B) or (HotKey[0] = $5C)) and
               ((HotKey[1] = $A0) or (HotKey[1] = $A1) or (HotKey[1] = $A2) or (HotKey[1] = $A3) or (HotKey[1] = $A4) or (HotKey[1] = $A5) or (HotKey[1] = $5B) or (HotKey[1] = $5C)) and
               ((HotKey[2] = $A0) or (HotKey[2] = $A1) or (HotKey[2] = $A2) or (HotKey[2] = $A3) or (HotKey[2] = $A4) or (HotKey[2] = $A5) or (HotKey[2] = $5B) or (HotKey[2] = $5C)) then
            begin
              keybd_event(HotKey[0], 0, 0, 0);
              keybd_event(HotKey[1], 0, 0, 0);
              keybd_event(HotKey[2], 0, 0, 0);
              keybd_event(HotKey[3], 0, 0, 0);
              keybd_event(HotKey[3], 0, KEYEVENTF_KEYUP, 0);
              keybd_event(HotKey[2], 0, KEYEVENTF_KEYUP, 0);
              keybd_event(HotKey[1], 0, KEYEVENTF_KEYUP, 0);
              keybd_event(HotKey[0], 0, KEYEVENTF_KEYUP, 0);
              flagkey := 1;
            end;
           if flagkey = 1 then begin
             AResponseInfo.ContentText:='<html>Ok!'+Value+'<p>true</p></html>';
             flagkey := 0;
            end
           else begin
             AResponseInfo.ContentText:='<html>Error!'+Value+'<p>false</p></html>';
             flagkey := 0;
           end;
        key.Free
          end;
       end;

      end;
  end;
end;
///////////////////****************************///////////////////////////////
procedure TServer.BtnSaveClick(Sender: TObject);
var appINI:TIniFile;
    FullProgPath: PChar;
    HTTP: TIdHTTP;
    Port,Host:String;
    a:Integer;
begin
 HTTP := TidHTTP.Create(nil);
 Port := MainServerPort.Text;
 Host := MainServer.Text;
 ReleaseMutex(H);
 CloseHandle(H);
  if (SimpleAPI_IP.Text <> '') and (SimpleAPI_Port.Text <> '') then
    begin
      HTTP.get('http://'+SimpleAPI_IP.Text+':'+SimpleAPI_Port.Text+'/set/GetAdmin.Host?value='+Host+'&prettyPrint');
      HTTP.get('http://'+SimpleAPI_IP.Text+':'+SimpleAPI_Port.Text+'/set/GetAdmin.Port?value='+Port+'&prettyPrint');
    end;
 appINI := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
 idHttpserver1.Active:=false;
   try
     appINI.WriteString('Properties','Lang', IntToStr(Language.ItemIndex));
     appINI.WriteString('Properties','Port', MainServerPort.Text);
     appINI.WriteString('Properties','BaseURL', MainServer.Text);
     if (StartUp.Checked ) then
      appINI.WriteString('Properties','AutoStart', '1')
     else begin
      appINI.WriteString('Properties','AutoStart', '0');
       end;
     if (ToTray.Checked ) then
      appINI.WriteString('Properties','ToTray', '1')
     else  begin
      appINI.WriteString('Properties','ToTray', '0');
      end;
     appINI.WriteString('Properties','SimpleAPI_IP', SimpleAPI_IP.Text);
     appINI.WriteString('Properties','SimpleAPI_Port', SimpleAPI_Port.Text);
     if (StrtoInt(Count1.Text)>100) then
       Count1.Text := '100';
     appINI.WriteString('Properties','Count', Count1.Text);
     for a:=0 to ((StrToInt(Count1.Text))-1) do
      begin
          appINI.WriteString('Commands','Command_'+IntToStr(a), command[a].Text);
          appINI.WriteString('Commands','Path_'+IntToStr(a), path[a].Text);
          appINI.WriteString('Commands','Param_'+IntToStr(a), param[a].Text);
          if (showas[a].Text<>'') then
            begin
              appINI.WriteString('Commands','show_'+IntToStr(a), showas[a].Text);
            end
          else
            begin
              appINI.WriteString('Commands','show_'+IntToStr(a), 'SW_SHOWNORMAL');
            end;
      end;

   finally
     appINI.Free;
   end;
    FullProgPath:=PChar(Application.ExeName);
    WinExec(FullProgPath,SW_SHOW);
    Application.Terminate;
   // INIfiles
end;
///////////////////////////////////////////////////////////////////////////////////
procedure TServer.ClickerOpenpath(Sender:TObject);
var i: Integer;
begin
 for i:=0 to (StrToInt(Count1.Text)-1) do
  if Sender = openpath[i] then indexOpenpath:=i;
  if OpenDialog1.Execute then
    path[indexOpenpath].Text:=OpenDialog1.FileName;
end;

procedure TServer.ClickTedit(Sender:TObject);
var i: Integer;
begin
 for i:=0 to (StrToInt(Count1.Text)-1) do
 begin
  if Sender = command[i] then
    begin
      command[i].SelectAll;
    end;
  if Sender = path[i] then
      begin
      path[i].SelectAll;
    end;
  if Sender = param[i] then
      begin
      param[i].SelectAll;
    end;
  if Sender = showas[i] then
      begin
      showas[i].SelectAll;
    end;
  end;
end;

procedure TServer.CoolTrayIcon1DblClick(Sender: TObject);
begin
  Server.Show;
  Application.Restore;
end;

procedure TServer.N1Click(Sender: TObject);
begin
  idHttpserver1.Active:=false;
  HALT;
end;

procedure TServer.N2Click(Sender: TObject);
begin
  Server.Show;
  Application.Restore;
end;

procedure TServer.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//PostMessage(Handle, WM_SYSCOMMAND, SC_MINIMIZE, 0);
  idHttpserver1.Active:=false;
  HALT;
end;

procedure TServer.BitBtn17Click(Sender: TObject);
  begin
    idHttpserver1.Active:=false;
    HALT;
  end;

procedure TServer.Label3DblClick(Sender: TObject);
  begin
    ShellExecute(Server.Handle, 'open', 'http://www.instalator.ru', nil, nil, SW_SHOW)
  end;

procedure TServer.GetRunProcess(ProcesList: TStringList);
var hSnapShot: THandle;
  ProcInfo: TProcessEntry32;
  n:Integer;
  ProcListResponse: string;
        begin
           ProcesList := TStringList.Create;
           hSnapShot := CreateToolHelp32Snapshot(TH32CS_SNAPPROCESS, 0);
           if ProcesList = nil then Exit;
             if (hSnapShot <> THandle(-1)) then
                begin
                 ProcInfo.dwSize := SizeOf(ProcInfo);
                  if (Process32First(hSnapshot, ProcInfo)) then
                    begin
                     while (Process32Next(hSnapShot, ProcInfo)) do
                     ProcesList.Add(ProcInfo.szExeFile);
                    end;
                 CloseHandle(hSnapShot);
                end;
         end;

 ////   //////
function TServer.EXE_Running(FileName: string; bFullpath: Boolean): Boolean;
var
  i,n: Integer;
  ProcListResponse:String;
  hSnapShot: THandle;
  ProcInfo: TProcessEntry32;
begin
  try
           ProcesList := TStringList.Create;
           hSnapShot := CreateToolHelp32Snapshot(TH32CS_SNAPPROCESS, 0);
             if (hSnapShot <> THandle(-1)) then
                begin
                 ProcInfo.dwSize := SizeOf(ProcInfo);
                  if (Process32First(hSnapshot, ProcInfo)) then
                    begin
                     while (Process32Next(hSnapShot, ProcInfo)) do
                      ProcesList.Add(ProcInfo.szExeFile);
                     end;
                 CloseHandle(hSnapShot);
                end;
    Result := False;
    if ProcesList = nil then Exit;
    for i := 0 to ProcesList.Count - 1 do
    begin
      if not bFullpath then
      begin
        if CompareText(ExtractFileName(ProcesList.Strings[i]), FileName) = 0 then
          Result := True
      end
      else if CompareText(ProcesList.strings[i], FileName) = 0 then Result := True;
      if Result then Break;
    end;
  finally
    ProcesList.Free;
  end;
end;

procedure TServer.Label13Click(Sender: TObject);
begin
      About := TAbout.Create(Self);
      About.BorderStyle := bsDialog;
      About.version.Caption := version;
      About.label5.AutoSize := False;
      /////
      if Language.ItemIndex = 1 then
      begin
       About.label5.Caption := 'The program is delivered by a principle "AS IS". No warranty is not attached and is not provided. You use this software at your own risk.'+' The author will not be responsible for any loss or corruption of data, any loss of profit during use or misuse of this software.';
      end;
      if Language.ItemIndex = 0 then
      begin
       About.label5.Caption := '    " " ("AS IS").      .          .'+'           ,            .';
      end;
      /////////

      About.Label6.Cursor := crHandPoint;
      About.Label6.Font.Color := clBlue;

      rez := About.ShowModal;
      About.Free;
end;

procedure TServer.ScrollBox1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
Scrollbox1.VertScrollBar.Position:= Scrollbox1.VertScrollBar.Position+4;
end;

procedure TServer.ScrollBox1MouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
Scrollbox1.VertScrollBar.Position:= Scrollbox1.VertScrollBar.Position-4;
end;

procedure TServer.CoolTrayIcon1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then PopupMenu1.Popup(X,Y);
end;

procedure TServer.ControlWindow(var Msg: TMessage);
begin
  If Msg.WParam = SC_MINIMIZE then
     begin
       ShowWindow(Application.Handle, SW_MINIMIZE);
     end
   else 
     inherited;
end;



end.









